import { SharedUtils as SharedUtils$1, Theme, $t } from 'primevue/themes';

var definePreset = (function () {
  var _SharedUtils$object;
  return (_SharedUtils$object = SharedUtils$1.object).mergeKeys.apply(_SharedUtils$object, arguments);
});

var updatePreset = (function () {
  var _SharedUtils$object;
  for (var _len = arguments.length, presets = new Array(_len), _key = 0; _key < _len; _key++) {
    presets[_key] = arguments[_key];
  }
  var newPreset = (_SharedUtils$object = SharedUtils$1.object).mergeKeys.apply(_SharedUtils$object, [Theme.getPreset()].concat(presets));
  Theme.setPreset(newPreset);
  return newPreset;
});

var updatePrimaryPalette = (function (primary) {
  return $t().primaryPalette(primary).update().preset;
});

var updateSurfacePalette = (function (surface) {
  return $t().surfacePalette(surface).update().preset;
});

var usePreset = (function () {
  var _SharedUtils$object;
  var newPreset = (_SharedUtils$object = SharedUtils.object).mergeKeys.apply(_SharedUtils$object, arguments);
  Theme.setPreset(newPreset);
  return newPreset;
});

var useTheme = (function (theme) {
  return $t(theme).update({
    mergePresets: false
  });
});

export { definePreset, updatePreset, updatePrimaryPalette, updateSurfacePalette, usePreset, useTheme };
//# sourceMappingURL=index.mjs.map
